<template>
  <bh-bizcard-list-ui
    :bizcards="filteredBizcards"
    :filters="filters"
    :status="status"
  />
</template>

<script>
export default {
  name: 'BhBizcardList',
  props: {
    filters: {
      type: Object,
      default: () => ({}),
    },
  },
  async fetch() {
    try {
      const bizcards = await this.$dataService.getBizcards();
      this.$store.dispatch('bizcards/setBizcards', bizcards);
    } catch (error) {
      const next = {
        404: { path: '/no-active-bizcards', query: null },
        500: { path: '/server-error', query: { mid: 'bizcards.fetch.error' } },
      };
      // prettier-ignore
      const { path, query } = error.message === 'NoActiveBizcards' ? next[404] : next[500];

      if (process.server) {
        this.$nuxt.context.redirect(path, query);
      }
      if (process.client) {
        this.$router.push({ path, query });
      }
    }
  },
  // fetchOnServer: process.env.NODE_ENV !== 'development',
  computed: {
    filteredBizcards() {
      return this.$store.getters['bizcards/getFilteredBizcards'];
    },
    status() {
      if (this.$fetchState.error) return 'error';
      if (this.$fetchState.pending) return 'pending';
      return 'idle';
    },
  },
};
</script>
